<?php
/*
Plugin Name: Categories Images - Modded
Plugin URI: http://zahlan.net/blog/2012/06/categories-images/
Description: Categories Images Plugin allow you to add an image to category or any custom term.
Author: Muhammad Said El Zahlan
Version: 1.2
Author URI: http://zahlan.net/
*/
/*
ED ADDED IMAGE ID, HACKILY, BUT IT WORKS.
*/
?>
<?php
// inti the plugin
add_action('admin_head', 'z_inti');
function z_inti() {
	$z_taxonomies = get_taxonomies();
	if (is_array($z_taxonomies)) {
	    foreach ($z_taxonomies as $z_taxonomy ) {
	        add_action($z_taxonomy.'_add_form_fields', 'z_add_texonomy_field');
			add_action($z_taxonomy.'_edit_form_fields', 'z_edit_texonomy_field');
	    }
	}
}

// add image field in add form
function z_add_texonomy_field() {
wp_enqueue_style('thickbox');
wp_enqueue_script('thickbox');
	echo '<div class="form-field">
		<label for="taxonomy_image">Image</label>
		<input type="text" name="taxonomy_image" id="taxonomy_image" value="" />
		<p>The ID of the category image.</p>
		<a href="#" id="upload_taxonomy_image">Upload/select image</a>
	</div>'.z_script();
}

// add image field in edit form
function z_edit_texonomy_field($taxonomy) {
wp_enqueue_style('thickbox');
wp_enqueue_script('thickbox');
	echo '<tr class="form-field">
		<th scope="row" valign="top"><label for="taxonomy_image">Image</label></th>
		<td>
			<input type="text" name="taxonomy_image" id="taxonomy_image" value="'.get_option('z_taxonomy_image'.$taxonomy->term_id).'" /><br />
			<p>The ID of the category image. Leave empty to remove. <a href="#" id="upload_taxonomy_image">Upload/select image</a></p>
		</td>
	</tr>'.z_script();
}
// upload using wordpress upload
function z_script() {
	return '<script type="text/javascript">
	    jQuery(document).ready(function() {
			jQuery("#upload_taxonomy_image").click(function() {
				tb_show("", "media-upload.php?type=image&amp;TB_iframe=true");
				return false;
			});
			window.send_to_editor = function(html) {
				imgclass = jQuery("img",html).attr("class");
				classlocation = imgclass.search("wp-image-") + 9;
				imgid = imgclass.slice( classlocation );
				jQuery("#taxonomy_image").val(imgid);
				tb_remove();
			}
	    });
	</script>';
}

// save our taxonomy image while edit or save term

//ed woz here lol
add_action('edit_term','z_save_taxonomy_image');
add_action('create_term','z_save_taxonomy_image');
function z_save_taxonomy_image($term_id) {

	$form_field = $_POST['taxonomy_image'];
	$is_image_id = wp_get_attachment_image( intval($form_field) );

    if ( $is_image_id == true ) {
    	$image_id = $form_field;
    } else {
    	$image_id = null;
    }
    update_option('z_taxonomy_image'.$term_id, $image_id);
}

// output taxonomy image id for the given term_id (NULL by default)
function z_taxonomy_image_id($term_id = NULL) {
	if (!$term_id) {
		if (is_category())
			$term_id = get_query_var('cat');
		elseif (is_tax()) {
			$current_term = get_term_by('slug', get_query_var('term'), get_query_var('taxonomy'));
			$term_id = $current_term->term_id;
		}
	}
    return get_option('z_taxonomy_image'.$term_id);
}

?>